% always make l bigger than m & coprime
function [y,z]=adjoint_homo_nondim_H(k,B,C,epsilon_2,a_c,psi1,psi2,m,l,p,...
    m_forcing,l_forcing,p_forcing,N,visc_option)
% modes in time plus zero mode, max mode N-1
% harmonic, mu=0
A=zeros(2*N,2*N);
RHS=A;
FACTOR_MID=-4*epsilon_2*(k)^2;
FACTOR_END=abs(k)*(B+C*k^2);
FACTOR_RHS=B*k*a_c/2;
visc_2=visc_option*4*epsilon_2^2*k^4;
for n=1:2:2*p-1
    n_count=(n-1)/2;
    % matrix A
    E_A=-(n_count)^2+FACTOR_MID*1i*(n_count)...
        +FACTOR_END+visc_2;
    A(n,n)=real(E_A); A(n,n+1)=-imag(E_A);%C%C
    A(n+1,n)=imag(E_A); A(n+1,n+1)=real(E_A);%C%C
    % make matrix B
    RHS(n,2*(abs(n_count-p))+1)=RHS(n,2*(abs(n_count-p))+1)-p_forcing*cos(psi2);%C%C
    RHS(n,2*(abs(n_count-p))+2)=RHS(n,2*(abs(n_count-p))+2)-p_forcing*sin(psi2);%C%C
    RHS(n+1,2*(abs(n_count-p))+1)=RHS(n+1,2*(abs(n_count-p))+1)-p_forcing*sin(psi2);%C%C
    RHS(n+1,2*(abs(n_count-p))+2)=RHS(n+1,2*(abs(n_count-p))+2)+p_forcing*cos(psi2);
    if n_count-l<0
    RHS(n,2*(abs(n_count-l))+1)=RHS(n,2*(abs(n_count-l))+1)-l_forcing*cos(psi1);%C%C
    RHS(n,2*(abs(n_count-l))+2)=RHS(n,2*(abs(n_count-l))+2)-l_forcing*sin(psi1);%C%C
    RHS(n+1,2*(abs(n_count-l))+1)=RHS(n+1,2*(abs(n_count-l))+1)-l_forcing*sin(psi1);%C%C
    RHS(n+1,2*(abs(n_count-l))+2)=RHS(n+1,2*(abs(n_count-l))+2)+l_forcing*cos(psi1);%C%C
    else
    RHS(n,n-2*l)=RHS(n,n-2*l)-l_forcing*cos(psi1);%C%C
    RHS(n,n-2*l+1)=RHS(n,n-2*l+1)+l_forcing*sin(psi1);%C%C
    RHS(n+1,n-2*l)=RHS(n+1,n-2*l)-l_forcing*sin(psi1);%C%C
    RHS(n+1,n-2*l+1)=RHS(n+1,n-2*l+1)-l_forcing*cos(psi1);%C%C
    end
    
    if n_count-m<0
    RHS(n,2*(abs(n_count-m))+1)=RHS(n,2*(abs(n_count-m))+1)-m_forcing;%C%C
    RHS(n+1,2*(abs(n_count-m))+2)=RHS(n+1,2*(abs(n_count-m))+2)+m_forcing;%C%C
    else
    RHS(n,n-2*m)=RHS(n,n-2*m)-m_forcing;%C%C
    RHS(n+1,n-2*m+1)=RHS(n+1,n-2*m+1)-m_forcing;%C%C
    end
    
    RHS(n,n+2*m)=RHS(n,n+2*m)-m_forcing;%C%C
    RHS(n,n+2*l)=RHS(n,n+2*l)-l_forcing*cos(psi1);%C%C
    RHS(n,n+2*l+1)=RHS(n,n+2*l+1)-l_forcing*sin(psi1);%C%C
    RHS(n,n+2*p)=RHS(n,n+2*p)-p_forcing*cos(psi2);%C%C
    RHS(n,n+2*p+1)=RHS(n,n+2*p+1)-p_forcing*sin(psi2);%C%C

    RHS(n+1,n+2*m+1)=RHS(n+1,n+2*m+1)-m_forcing;%C%C
    RHS(n+1,n+2*l)=RHS(n+1,n+2*l)+l_forcing*sin(psi1);%C%C
    RHS(n+1,n+2*l+1)=RHS(n+1,n+2*l+1)-l_forcing*cos(psi1);%C%C
    RHS(n+1,n+2*p)=RHS(n+1,n+2*p)+p_forcing*sin(psi2);%C%C
    RHS(n+1,n+2*p+1)=RHS(n+1,n+2*p+1)-p_forcing*cos(psi2);%C%C
end %C
for n=2*p+1:2:2*N-2*p-1
    % make matrix A
    n_count=(n-1)/2;
    E_A=-(n_count)^2+FACTOR_MID*1i*(n_count)...
        +FACTOR_END+visc_2;
    A(n,n)=real(E_A); A(n,n+1)=-imag(E_A);%C
    A(n+1,n)=imag(E_A); A(n+1,n+1)=real(E_A);%C

    % make matrix B
    RHS(n,n-2*p)=-p_forcing*cos(psi2);%C%C
    RHS(n,n-2*p+1)=p_forcing*sin(psi2);%C%C
    RHS(n,n-2*l)=-l_forcing*cos(psi1);%C%C
    RHS(n,n-2*l+1)=l_forcing*sin(psi1);%C%C
    RHS(n,n-2*m)=-m_forcing;%C%C
    RHS(n,n+2*m)=-m_forcing;%C%C
    RHS(n,n+2*l)=-l_forcing*cos(psi1);%C%C
    RHS(n,n+2*l+1)=-l_forcing*sin(psi1);%C%C
    RHS(n,n+2*p)=-p_forcing*cos(psi2);%C%C
    RHS(n,n+2*p+1)=-p_forcing*sin(psi2);%C%C
    
    RHS(n+1,n-2*p)=-p_forcing*sin(psi2);%C%C
    RHS(n+1,n-2*p+1)=-p_forcing*cos(psi2);%C%C
    RHS(n+1,n-2*l)=-l_forcing*sin(psi1);%C%C
    RHS(n+1,n-2*l+1)=-l_forcing*cos(psi1);%C%C
    RHS(n+1,n-2*m+1)=-m_forcing;%C%C
    RHS(n+1,n+2*m+1)=-m_forcing;%C%C
    RHS(n+1,n+2*l)=l_forcing*sin(psi1);%C%C
    RHS(n+1,n+2*l+1)=-l_forcing*cos(psi1);%C%C
    RHS(n+1,n+2*p)=p_forcing*sin(psi2);%C%C
    RHS(n+1,n+2*p+1)=-p_forcing*cos(psi2);%C%C
end
for n=2*N-2*p+1:2:2*N-1 % remember you have zero mode
    n_count=(n-1)/2;
    % matrix A
    E_A=-(n_count)^2+FACTOR_MID*1i*(n_count)...
        +FACTOR_END+visc_2;
    A(n,n)=real(E_A); A(n,n+1)=-imag(E_A);%C
    A(n+1,n)=imag(E_A); A(n+1,n+1)=real(E_A);%C
    % make matrix B
    RHS(n,n-2*p)=-p_forcing*cos(psi2);%C%C
    RHS(n,n-2*p+1)=p_forcing*sin(psi2);%C%C
    RHS(n,n-2*l)=-l_forcing*cos(psi1);%C%C
    RHS(n,n-2*l+1)=l_forcing*sin(psi1);%C%C
    RHS(n,n-2*m)=-m_forcing;%C%C
    if n_count+m<=N-1
    RHS(n,n+2*m)=-m_forcing;%C%C %real
    RHS(n+1,n+2*m+1)=-m_forcing;%C%C %imag
    end
    if n_count+l<=N-1
    RHS(n,n+2*l)=-l_forcing*cos(psi1);%C%C
    RHS(n,n+2*l+1)=-l_forcing*sin(psi1);
    RHS(n+1,n+2*l)=l_forcing*sin(psi1);%C%C
    RHS(n+1,n+2*l+1)=-l_forcing*cos(psi1);
    end
    
    RHS(n+1,n-2*p)=-p_forcing*sin(psi2);%C%C
    RHS(n+1,n-2*p+1)=-p_forcing*cos(psi2);%C%C
    RHS(n+1,n-2*l)=-l_forcing*sin(psi1);%C%C
    RHS(n+1,n-2*l+1)=-l_forcing*cos(psi1);%C%C
    RHS(n+1,n-2*m+1)=-m_forcing;%C%C
 end
    clear P D J J_2 J_4 J_3 J_22
    [P,D]=eig(A\(FACTOR_RHS*RHS));
    
    J=diag(D);
    
    p_count=1;
    for I=1:length(J)
        if abs(imag(J(I,1)))<1e-9
            J_2(p_count)=real(J(I,1));
            J_22(:,p_count)=P(:,I);
            p_count=p_count+1;
        end 
    end
    q_count=1;
    while abs(J_2(q_count)-1)>1e-10
        q_count=q_count+1;
    end
    J_3=J_2(q_count);
    y=1/J_3;
    z=J_22(:,q_count);
end
