% always make l bigger than m & coprime
function [y,z]=find_a_at_k_3freq_SH_all_info(k,B_gam,C,epsilon_2,...
    psi1,psi2,m,l,p,m_forcing,l_forcing,p_forcing,N,visc_option)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%5
% subharmonic, mu=0.5
A=zeros(2*N,2*N);%CHECKED
B=A;%CHECKED
visc_2=visc_option*4*epsilon_2^2*k^4;
for n=1:2:2*p-1
    n_count=(n-1)/2;
    % matrix A
    E_A=(2/B_gam)*((-(n_count+0.5)^2+4*epsilon_2*1i*k^2*(n_count+0.5)+visc_2)/k...
        +((B_gam+C*k^2)));%CHECKED
    A(n,n)=real(E_A); A(n,n+1)=-imag(E_A);%C
    A(n+1,n)=imag(E_A); A(n+1,n+1)=real(E_A);%C
    
    % make matrix B
    B(n,2*(abs(n_count-p)-1)+1)=B(n,2*(abs(n_count-p)-1)+1)-p_forcing*cos(psi2);%C%C
    B(n,2*(abs(n_count-p)-1)+2)=B(n,2*(abs(n_count-p)-1)+2)-p_forcing*sin(psi2);%C%C
    B(n+1,2*(abs(n_count-p)-1)+1)=B(n+1,2*(abs(n_count-p)-1)+1)-p_forcing*sin(psi2);%C%C
    B(n+1,2*(abs(n_count-p)-1)+2)=B(n+1,2*(abs(n_count-p)-1)+2)+p_forcing*cos(psi2);
    % n<l
    if n_count-l<0
    B(n,2*(abs(n_count-l)-1)+1)=B(n,2*(abs(n_count-l)-1)+1)-l_forcing*cos(psi1);%C%C
    B(n,2*(abs(n_count-l)-1)+2)=B(n,2*(abs(n_count-l)-1)+2)-l_forcing*sin(psi1);%C%C
    B(n+1,2*(abs(n_count-l)-1)+1)=B(n+1,2*(abs(n_count-l)-1)+1)-l_forcing*sin(psi1);%C%C
    B(n+1,2*(abs(n_count-l)-1)+2)=B(n+1,2*(abs(n_count-l)-1)+2)+l_forcing*cos(psi1);%C%C
    else
    B(n,n-2*l)=B(n,n-2*l)-l_forcing*cos(psi1);%C%C
    B(n,n-2*l+1)=B(n,n-2*l+1)+l_forcing*sin(psi1);%C%C
    B(n+1,n-2*l)=B(n+1,n-2*l)-l_forcing*sin(psi1);%C%C
    B(n+1,n-2*l+1)=B(n+1,n-2*l+1)-l_forcing*cos(psi1);
    end
    if n_count-m<0
    B(n,2*(abs(n_count-m)-1)+1)=B(n,2*(abs(n_count-m)-1)+1)-m_forcing;%C%C%C%C
    B(n+1,2*(abs(n_count-m)-1)+2)=B(n+1,2*(abs(n_count-m)-1)+2)+m_forcing;%C%C%C%C
    else
    B(n,2*(n_count-m)+1)=B(n,2*(n_count-m)+1)-m_forcing;%C%C%C%C
    B(n+1,2*(n_count-m)+2)=B(n+1,2*(n_count-m)+2)-m_forcing;%C%C%C%C
    end
        
    B(n,n+2*m)=B(n,n+2*m)-m_forcing;%C%C
    B(n,n+2*l)=B(n,n+2*l)-l_forcing*cos(psi1);%C%C
    B(n,n+2*l+1)=B(n,n+2*l+1)-l_forcing*sin(psi1);%C%C
    B(n,n+2*p)=B(n,n+2*p)-p_forcing*cos(psi2);%C%C
    B(n,n+2*p+1)=B(n,n+2*p+1)-p_forcing*sin(psi2);%C%C

    B(n+1,n+2*m+1)=B(n+1,n+2*m+1)-m_forcing;%C%C
    B(n+1,n+2*l)=B(n+1,n+2*l)+l_forcing*sin(psi1);%C%C
    B(n+1,n+2*l+1)=B(n+1,n+2*l+1)-l_forcing*cos(psi1);%C%C
    B(n+1,n+2*p)=B(n+1,n+2*p)+p_forcing*sin(psi2);%C%C
    B(n+1,n+2*p+1)=B(n+1,n+2*p+1)-p_forcing*cos(psi2);%C%C
end
for n=2*p+1:2:2*N-2*p-1
    % make matrix A
    n_count=(n-1)/2;
    E_A=(2/B_gam)*((-(n_count+0.5)^2+4*epsilon_2*1i*k^2*(n_count+0.5)+visc_2)/k...
        +((B_gam+C*k^2)));%CHECKED
    A(n,n)=real(E_A); A(n,n+1)=-imag(E_A);%C
    A(n+1,n)=imag(E_A); A(n+1,n+1)=real(E_A);%C

    % make matrix B
    B(n,n-2*p)=-p_forcing*cos(psi2);%C%C
    B(n,n-2*p+1)=p_forcing*sin(psi2);%C%C
    B(n,n-2*l)=-l_forcing*cos(psi1);%C%C
    B(n,n-2*l+1)=l_forcing*sin(psi1);%C%C
    B(n,n-2*m)=-m_forcing;%C%C
    B(n,n+2*m)=-m_forcing;%C%C
    B(n,n+2*l)=-l_forcing*cos(psi1);%C%C
    B(n,n+2*l+1)=-l_forcing*sin(psi1);%C%C
    B(n,n+2*p)=-p_forcing*cos(psi2);%C%C
    B(n,n+2*p+1)=-p_forcing*sin(psi2);%C%C

    B(n+1,n-2*p)=-p_forcing*sin(psi2);%C%C
    B(n+1,n-2*p+1)=-p_forcing*cos(psi2);%C%C
    B(n+1,n-2*l)=-l_forcing*sin(psi1);%C%C
    B(n+1,n-2*l+1)=-l_forcing*cos(psi1);%C%C
    B(n+1,n-2*m+1)=-m_forcing;%C%C
    B(n+1,n+2*m+1)=-m_forcing;%C%C
    B(n+1,n+2*l)=l_forcing*sin(psi1);%C%C
    B(n+1,n+2*l+1)=-l_forcing*cos(psi1);%C%C
    B(n+1,n+2*p)=p_forcing*sin(psi2);%C%C
    B(n+1,n+2*p+1)=-p_forcing*cos(psi2);%C%C
end
for n=2*N-2*p+1:2:2*N-1
    n_count=(n-1)/2;
    % matrix A
    E_A=(2/B_gam)*((-(n_count+0.5)^2+4*epsilon_2*1i*k^2*(n_count+0.5)+visc_2)/k...
        +((B_gam+C*k^2)));%CHECKED
    A(n,n)=real(E_A); A(n,n+1)=-imag(E_A);%C
    A(n+1,n)=imag(E_A); A(n+1,n+1)=real(E_A);%C
    % make matrix B
    B(n,n-2*p)=-p_forcing*cos(psi2);%C
    B(n,n-2*p+1)=p_forcing*sin(psi2);%C
    B(n,n-2*l)=-l_forcing*cos(psi1);%C
    B(n,n-2*l+1)=l_forcing*sin(psi1);%C
    B(n,n-2*m)=-m_forcing;%C
    if n_count+m<=N-1
    B(n,n+2*m)=-m_forcing;%C%C
    B(n+1,n+2*m+1)=-m_forcing;%C%C
    end
    if n_count+l<=N-1
    B(n,n+2*l)=-l_forcing*cos(psi1);%C%C
    B(n,n+2*l+1)=-l_forcing*sin(psi1);
    B(n+1,n+2*l)=l_forcing*sin(psi1);%C%C
    B(n+1,n+2*l+1)=-l_forcing*cos(psi1);
    end
    
    B(n+1,n-2*p)=-p_forcing*sin(psi2);%C%C
    B(n+1,n-2*p+1)=-p_forcing*cos(psi2);%C%C
    B(n+1,n-2*l)=-l_forcing*sin(psi1);%C%C
    B(n+1,n-2*l+1)=-l_forcing*cos(psi1);%C%C
    B(n+1,n-2*m+1)=-m_forcing;%C%C
 end
    [P,D]=eig(A\B);
    J=diag(D);
    p_count=1;
    for I=1:length(J)
        if abs(imag(J(I,1)))<1e-9
            J_2(p_count)=real(J(I,1));
            J_22(:,p_count)=P(:,I);
            p_count=p_count+1;
        end 
    end
    [J_3,J_position]=max((J_2));
    y=1/J_3;
    z=J_22(:,J_position);
end
