function y=solve_second_order_k1pk2_SH(p_1,h_1,B,C,epsilon_2,k_1,k_2,a_c,...
    psi1,psi2,m,l,p,m_forcing,l_forcing,p_forcing,visc_option)
% solver at second order for h2_ll, NOT subharmonic
N=length(p_1); %CHECKED
h=full_SH(h_1); %CHECKED
p1=full_SH(p_1); %CHECKED
k=norm(k_1+k_2); %CHECKED
A=zeros(2*N,2*N); %CHECKED
rhs=zeros(2*N,1); %CHECKED
FACTOR_MID=4*epsilon_2*(k)^2*1i; %CHECKED
FACTOR_END=(k)*(B+C*(k)^2); %CHECKED
FACTOR_FORCING=B*((k)/2)*a_c; %CHECKED
visc_2=visc_option*4*epsilon_2^2*k^4;

for n=1:2:2*p-1 % because you have a zero mode
    n_count=(n-1)/2;%CHECKED
    E_A=-(n_count)^2+FACTOR_MID*(n_count)...
        +FACTOR_END+visc_2;%CHECKED
    % for n_count-p<0
    A(n,2*abs(n_count-p)+1)=A(n,2*abs(n_count-p)+1)+FACTOR_FORCING*p_forcing*cos(psi2);%CHECKED
    A(n,2*abs(n_count-p)+2)=A(n,2*abs(n_count-p)+2)+FACTOR_FORCING*p_forcing*sin(psi2);%CHECKED
    % for n_count-l maybe < 0
    if n_count-l<0%CHECKED
    A(n,2*abs(n_count-l)+1)=A(n,2*abs(n_count-l)+1)+FACTOR_FORCING*l_forcing*cos(psi1);%CHECKED
    A(n,2*abs(n_count-l)+2)=A(n,2*abs(n_count-l)+2)+FACTOR_FORCING*l_forcing*sin(psi1);%CHECKED flip sign of imag part
    else
    A(n,n-2*l)=A(n,n-2*l)+FACTOR_FORCING*l_forcing*cos(psi1);%CHECKED
    A(n,n-2*l+1)=A(n,n-2*l+1)-FACTOR_FORCING*l_forcing*sin(psi1);%CHECKED
    end
    % for n_count-m maybe < 0
    if n_count-m<0%CHECKED
        A(n,2*abs(n_count-m)+1)=A(n,2*abs(n_count-m)+1)+FACTOR_FORCING*m_forcing;%CHECKED
    else
        A(n,n-2*m)=A(n,n-2*m)+FACTOR_FORCING*m_forcing;%CHECKED
    end
    % others
    A(n,n)=A(n,n)+real(E_A);%CHECKED
    A(n,n+1)=A(n,n+1)-imag(E_A);%CHECKED
    A(n,n+2*m)=A(n,n+2*m)+FACTOR_FORCING*m_forcing;%CHECKED
    A(n,n+2*l)=A(n,n+2*l)+FACTOR_FORCING*l_forcing*cos(psi1);%CHECKED
    A(n,n+2*l+1)=A(n,n+2*l+1)+FACTOR_FORCING*l_forcing*sin(psi1);%CHECKED
    A(n,n+2*p)=A(n,n+2*p)+FACTOR_FORCING*p_forcing*cos(psi2);%CHECKED
    A(n,n+2*p+1)=A(n,n+2*p+1)+FACTOR_FORCING*p_forcing*sin(psi2);%CHECKED
    %CHECKED
    % imag
    A(n+1,2*abs(n_count-p)+1)=A(n+1,2*abs(n_count-p)+1)+FACTOR_FORCING*p_forcing*sin(psi2);%CHECKED
    A(n+1,2*abs(n_count-p)+2)=A(n+1,2*abs(n_count-p)+2)-FACTOR_FORCING*p_forcing*cos(psi2);%CHECKED
    if n_count-l<0%CHECKED
    A(n+1,2*abs(n_count-l)+1)=A(n+1,2*abs(n_count-l)+1)+FACTOR_FORCING*l_forcing*sin(psi1);%CHECKED
    A(n+1,2*abs(n_count-l)+2)=A(n+1,2*abs(n_count-l)+2)-FACTOR_FORCING*l_forcing*cos(psi1);%CHECKED
    else
    A(n+1,n-2*l)=A(n+1,n-2*l)+FACTOR_FORCING*l_forcing*sin(psi1);%CHECKED
    A(n+1,n-2*l+1)=A(n+1,n-2*l+1)+FACTOR_FORCING*l_forcing*cos(psi1);%CHECKED
    end
    if n_count-m<0%CHECKED
        A(n+1,2*abs(n_count-m)+2)=A(n+1,2*abs(n_count-m)+2)-FACTOR_FORCING*m_forcing;%CHECKED
    else
        A(n+1,n-2*m+1)=A(n+1,n-2*m+1)+FACTOR_FORCING*m_forcing;%CHECKED
    end
    % others
    A(n+1,n)=A(n+1,n)+imag(E_A);%CHECKED
    A(n+1,n+1)=A(n+1,n+1)+real(E_A);%CHECKED
    A(n+1,n+2*m+1)=A(n+1,n+2*m+1)+FACTOR_FORCING*m_forcing;%CHECKED%M
    A(n+1,n+2*l)=A(n+1,n+2*l)-FACTOR_FORCING*l_forcing*sin(psi1);%CHECKED
    A(n+1,n+2*l+1)=A(n+1,n+2*l+1)+FACTOR_FORCING*l_forcing*cos(psi1);%CHECKED
    A(n+1,n+2*p)=A(n+1,n+2*p)-FACTOR_FORCING*p_forcing*sin(psi2);%CHECKED
    A(n+1,n+2*p+1)=A(n+1,n+2*p+1)+FACTOR_FORCING*p_forcing*cos(psi2);%CHECKED
    %CHECKED
    % rhs
    rhs_temp=0+0*1i;
    for r=1:length(p1) % index of pl %CHECKED
        r_wn=r-(N+1); % corresponding wavenumber -0.5, %CHECKED
        s_wn=n_count-r_wn-1; %'paired' wavenumber %CHECKED
        s=s_wn+(N+1); % corresponding index %CHECKED
        if s<2*N+1 && s>0 %CHECKED
        rhs_temp=rhs_temp+...
            (k^2-2*norm(k_1)*k)*(1i*(r_wn+s_wn+1)+2*epsilon_2*k^2)*h(r,1)*p1(s,1)+... %MISTAKE SHOULD BE (R_WN+S_WN+1)
        k*(norm(k_1)*norm(k_2)+dot(k_1,k_2))*p1(r,1)*p1(s,1);%CHECKED
        end
    end
    rhs(n,1)=0.5*real(rhs_temp);%CHECKED needs 0.5 factor
    rhs(n+1,1)=0.5*imag(rhs_temp);%CHECKED
end
for n=2*p+1:2:2*(N-p)-1 % because you have a zero mode%CHECKED
    n_count=(n-1)/2;%CHECKED
    E_A=-(n_count)^2+FACTOR_MID*(n_count)...%CHECKED
        +FACTOR_END+visc_2;%CHECKED
    % real
    A(n,n-2*p)=FACTOR_FORCING*p_forcing*cos(psi2);%CHECKED
    A(n,n-2*p+1)=-FACTOR_FORCING*p_forcing*sin(psi2);%CHECKED
    A(n,n-2*l)=FACTOR_FORCING*l_forcing*cos(psi1);%CHECKED
    A(n,n-2*l+1)=-FACTOR_FORCING*l_forcing*sin(psi1);%CHECKED
    A(n,n-2*m)=FACTOR_FORCING*m_forcing;%CHECKED
    A(n,n)=real(E_A);%CHECKED
    A(n,n+1)=-imag(E_A);%CHECKED
    A(n,n+2*m)=FACTOR_FORCING*m_forcing;%CHECKED
    A(n,n+2*l)=FACTOR_FORCING*l_forcing*cos(psi1);%CHECKED
    A(n,n+2*l+1)=FACTOR_FORCING*l_forcing*sin(psi1);%CHECKED
    A(n,n+2*p)=FACTOR_FORCING*p_forcing*cos(psi2);%CHECKED
    A(n,n+2*p+1)=FACTOR_FORCING*p_forcing*sin(psi2);%CHECKED
    
    % imag
    A(n+1,n-2*p)=FACTOR_FORCING*p_forcing*sin(psi2);%CHECKED
    A(n+1,n-2*p+1)=FACTOR_FORCING*p_forcing*cos(psi2);%CHECKED
    A(n+1,n-2*l)=FACTOR_FORCING*l_forcing*sin(psi1);%CHECKED
    A(n+1,n-2*l+1)=FACTOR_FORCING*l_forcing*cos(psi1);%CHECKED
    A(n+1,n-2*m+1)=FACTOR_FORCING*m_forcing;%CHECKED
    A(n+1,n)=imag(E_A);%CHECKED
    A(n+1,n+1)=real(E_A);%CHECKED
    A(n+1,n+2*m+1)=FACTOR_FORCING*m_forcing;%CHECKED%M
    A(n+1,n+2*l)=-FACTOR_FORCING*l_forcing*sin(psi1);%CHECKED
    A(n+1,n+2*l+1)=FACTOR_FORCING*l_forcing*cos(psi1);%CHECKED
    A(n+1,n+2*p)=-FACTOR_FORCING*p_forcing*sin(psi2);%CHECKED
    A(n+1,n+2*p+1)=FACTOR_FORCING*p_forcing*cos(psi2);%CHECKED
    
    % rhs
    rhs_temp=0+0*1i;
    for r=1:length(p1) % index of pl %CHECKED
        r_wn=r-(N+1); % corresponding wavenumber -0.5, %CHECKED
        s_wn=n_count-r_wn-1; %'paired' wavenumber %CHECKED
        s=s_wn+(N+1); % corresponding index %CHECKED
        if s<2*N+1 && s>0
        rhs_temp=rhs_temp+...
            (k^2-2*norm(k_1)*k)*(1i*(r_wn+s_wn+1)+2*epsilon_2*k^2)*h(r,1)*p1(s,1)+... %MISTAKE SHOULD BE (R_WN+S_WN+1)
        k*(norm(k_1)*norm(k_2)+dot(k_1,k_2))*p1(r,1)*p1(s,1);%CHECKED
        end
    end
    rhs(n,1)=0.5*real(rhs_temp);%CHECKED
    rhs(n+1,1)=0.5*imag(rhs_temp);%CHECKED
end
for n=2*(N-p)+1:2:2*N-1 % because you have a zero mode %CHECKED
    n_count=(n-1)/2;%CHECKED
    E_A=-(n_count)^2+FACTOR_MID*(n_count)...%CHECKED
        +FACTOR_END+visc_2;%CHECKED
    
    % real
    A(n,n-2*p)=FACTOR_FORCING*p_forcing*cos(psi2);%CHECKED
    A(n,n-2*p+1)=-FACTOR_FORCING*p_forcing*sin(psi2);%CHECKED
    A(n,n-2*l)=FACTOR_FORCING*l_forcing*cos(psi1);%CHECKED
    A(n,n-2*l+1)=-FACTOR_FORCING*l_forcing*sin(psi1);%CHECKED
    A(n,n-2*m)=FACTOR_FORCING*m_forcing;%CHECKED
    A(n,n)=real(E_A);%CHECKED
    A(n,n+1)=-imag(E_A);%CHECKED
    if n_count+l<=N-1
    A(n,n+2*l)=FACTOR_FORCING*l_forcing*cos(psi1);
    A(n,n+2*l+1)=FACTOR_FORCING*l_forcing*sin(psi1);
    end
    if n_count+m<=N-1%CHECKED%M
    A(n,n+2*m)=FACTOR_FORCING*m_forcing;%CHECKED
    end
    
    % imag
    A(n+1,n-2*p)=FACTOR_FORCING*p_forcing*sin(psi2);%CHECKED
    A(n+1,n-2*p+1)=FACTOR_FORCING*p_forcing*cos(psi2);%CHECKED
    A(n+1,n-2*l)=FACTOR_FORCING*l_forcing*sin(psi1);%CHECKED
    A(n+1,n-2*l+1)=FACTOR_FORCING*l_forcing*cos(psi1);%CHECKED
    A(n+1,n-2*m+1)=FACTOR_FORCING*m_forcing;%CHECKED
    A(n+1,n)=imag(E_A);%CHECKED
    A(n+1,n+1)=real(E_A);%CHECKED
    if n_count+l<=N-1%CHECKED
        A(n+1,n+2*l)=-FACTOR_FORCING*l_forcing*sin(psi1);%CHECKED
        A(n+1,n+2*l+1)=FACTOR_FORCING*l_forcing*cos(psi1);%CHECKED
    end
    if n_count+m<=N-1%CHECKED
    A(n+1,n+2*m+1)=FACTOR_FORCING*m_forcing;%CHECKED%Mistake
    end
    
    % rhs
    rhs_temp=0+0*1i;
    for r=1:length(p1) % index of pl %CHECKED
        r_wn=r-(N+1); % corresponding wavenumber -0.5, %CHECKED
        s_wn=n_count-r_wn-1; %'paired' wavenumber %CHECKED
        s=s_wn+(N+1); % corresponding index %CHECKED
        if s<2*N+1 && s>0
        rhs_temp=rhs_temp+...
            (k^2-2*norm(k_1)*k)*(1i*(r_wn+s_wn+1)+2*epsilon_2*k^2)*h(r,1)*p1(s,1)+... %MISTAKE SHOULD BE (R_WN+S_WN+1)
        k*(norm(k_1)*norm(k_2)+dot(k_1,k_2))*p1(r,1)*p1(s,1);%CHECKED
        end
    end
    rhs(n,1)=0.5*real(rhs_temp);%CHECKED
    rhs(n+1,1)=0.5*imag(rhs_temp);%CHECKED
end

y=A\rhs; %CHECKED