function y=solve_second_order_kk_H(p_m,B,C,epsilon_2,k_m,a_c,psi1,psi2,...
    m,l,p,m_forcing,l_forcing,p_forcing,visc_option)
% harmonic solver at second order
N=length(p_m); % number of time modes %CHECKED
p1=full_H(p_m);%CHECKED
A=zeros(2*N,2*N);%CHECKED
rhs=zeros(2*N,1);%CHECKED
k=2*norm(k_m);
FACTOR_MID=4*epsilon_2*(k)^2;%CHECKED
FACTOR_END=k*(B+C*(k)^2);%CHECKED
FACTOR_FORCING=B*(k/2)*a_c;%CHECKED
visc_2=visc_option*4*epsilon_2^2*k^4;

for n=1:2:2*p-1 % because you have a zero mode%CHECKED
    n_count=(n-1)/2;%CHECKED
    E_A=-(n_count)^2+FACTOR_MID*1i*(n_count)...%CHECKED
        +FACTOR_END+visc_2;%CHECKED
    % real
    A(n,2*abs(n_count-p)+1)=A(n,2*abs(n_count-p)+1)+FACTOR_FORCING*p_forcing*cos(psi2);%CHECKED
    A(n,2*abs(n_count-p)+2)=A(n,2*abs(n_count-p)+2)+FACTOR_FORCING*p_forcing*sin(psi2);%CHECKED
    if n_count-l<0
    A(n,2*abs(n_count-l)+1)=A(n,2*abs(n_count-l)+1)+FACTOR_FORCING*l_forcing*cos(psi1);%CHECKED
    A(n,2*abs(n_count-l)+2)=A(n,2*abs(n_count-l)+2)+FACTOR_FORCING*l_forcing*sin(psi1);%CHECKED % flip sign of imag part
    else
    A(n,n-2*l)=A(n,n-2*l)+FACTOR_FORCING*l_forcing*cos(psi1);%CHECKED
    A(n,n-2*l+1)=A(n,n-2*l+1)-FACTOR_FORCING*l_forcing*sin(psi1);%CHECKED
    end
    if n_count-m<0%CHECKED
        A(n,2*abs(n_count-m)+1)=A(n,2*abs(n_count-m)+1)+FACTOR_FORCING*m_forcing;%CHECKED
    else
        A(n,n-2*m)=A(n,n-2*m)+FACTOR_FORCING*m_forcing;%CHECKED
    end
    A(n,n)=A(n,n)+real(E_A); %CHECKED
    A(n,n+1)=A(n,n+1)-imag(E_A);%CHECKED
    A(n,n+2*m)=A(n,n+2*m)+FACTOR_FORCING*m_forcing;%CHECKED
    A(n,n+2*l)=A(n,n+2*l)+FACTOR_FORCING*l_forcing*cos(psi1);%CHECKED
    A(n,n+2*l+1)=A(n,n+2*l+1)+FACTOR_FORCING*l_forcing*sin(psi1);%CHECKED
    A(n,n+2*p)=A(n,n+2*p)+FACTOR_FORCING*p_forcing*cos(psi2);%CHECKED
    A(n,n+2*p+1)=A(n,n+2*p+1)+FACTOR_FORCING*p_forcing*sin(psi2);%CHECKED
    
    % imag
    A(n+1,2*abs(n_count-p)+1)=A(n+1,2*abs(n_count-p)+1)+FACTOR_FORCING*p_forcing*sin(psi2);%CHECKED
    A(n+1,2*abs(n_count-p)+2)=A(n+1,2*abs(n_count-p)+2)-FACTOR_FORCING*p_forcing*cos(psi2);%CHECKED
    if n_count-l<0%CHECKED
    A(n+1,2*abs(n_count-l)+1)=A(n+1,2*abs(n_count-l)+1)+FACTOR_FORCING*l_forcing*sin(psi1);%CHECKED
    A(n+1,2*abs(n_count-l)+2)=A(n+1,2*abs(n_count-l)+2)-FACTOR_FORCING*l_forcing*cos(psi1);%CHECKED
    else
    A(n+1,n-2*l)=A(n+1,n-2*l)+FACTOR_FORCING*l_forcing*sin(psi1);%CHECKED
    A(n+1,n-2*l+1)=A(n+1,n-2*l+1)+FACTOR_FORCING*l_forcing*cos(psi1);%CHECKED%Mistake
    end
    if n_count-m<0%CHECKED
        A(n+1,2*abs(n_count-m)+2)=A(n+1,2*abs(n_count-m)+2)-FACTOR_FORCING*m_forcing;%CHECKED
    else
        A(n+1,n-2*m+1)=A(n+1,n-2*m+1)+FACTOR_FORCING*m_forcing;%CHECKED
    end
    A(n+1,n)=A(n+1,n)+imag(E_A); %CHECKED
    A(n+1,n+1)=A(n+1,n+1)+real(E_A);%CHECKED
    A(n+1,n+2*m+1)=A(n+1,n+2*m+1)+FACTOR_FORCING*m_forcing;%CHECKED%MISTAKE
    A(n+1,n+2*l)=A(n+1,n+2*l)-FACTOR_FORCING*l_forcing*sin(psi1);%CHECKED
    A(n+1,n+2*l+1)=A(n+1,n+2*l+1)+FACTOR_FORCING*l_forcing*cos(psi1);%CHECKED
    A(n+1,n+2*p)=A(n+1,n+2*p)-FACTOR_FORCING*p_forcing*sin(psi2);%CHECKED
    A(n+1,n+2*p+1)=A(n+1,n+2*p+1)+FACTOR_FORCING*p_forcing*cos(psi2);%CHECKED
    % rhs
    rhs_temp=0+0*1i;
    for r=1:length(p1) % index of h
        r_wn=r-N; % corresponding wavenumber
        s_wn=n_count-r_wn; %'paired' wavenumber
        s=s_wn+N; % corresponding index
        if s<2*N && s>0
        rhs_temp=rhs_temp+k*(k/2)^2*p1(r,1)*p1(s,1);%CHECKED
        end
    end
    rhs(n,1)=real(rhs_temp);%CHECKED
    rhs(n+1,1)=imag(rhs_temp);%CHECKED
end

for n=2*p+1:2:2*(N-p)-1 % because you have a zero mode%CHECKED
    n_count=(n-1)/2;%CHECKED
    E_A=-(n_count)^2+FACTOR_MID*1i*(n_count)...%CHECKED
        +FACTOR_END+visc_2;%CHECKED
    % real
    A(n,n-2*p)=FACTOR_FORCING*p_forcing*cos(psi2);%CHECKED
    A(n,n-2*p+1)=-FACTOR_FORCING*p_forcing*sin(psi2);%CHECKED
    A(n,n-2*l)=FACTOR_FORCING*l_forcing*cos(psi1);%CHECKED
    A(n,n-2*l+1)=-FACTOR_FORCING*l_forcing*sin(psi1);%CHECKED
    A(n,n-2*m)=FACTOR_FORCING*m_forcing;%CHECKED
    A(n,n)=real(E_A); %CHECKED
    A(n,n+1)=-imag(E_A);%CHECKED
    A(n,n+2*m)=FACTOR_FORCING*m_forcing;%CHECKED
    A(n,n+2*l)=FACTOR_FORCING*l_forcing*cos(psi1);%CHECKED
    A(n,n+2*l+1)=FACTOR_FORCING*l_forcing*sin(psi1);%CHECKED
    A(n,n+2*p)=FACTOR_FORCING*p_forcing*cos(psi2);%CHECKED
    A(n,n+2*p+1)=FACTOR_FORCING*p_forcing*sin(psi2);%CHECKED
    % imag
    A(n+1,n-2*p)=FACTOR_FORCING*p_forcing*sin(psi2);%CHECKED
    A(n+1,n-2*p+1)=FACTOR_FORCING*p_forcing*cos(psi2);%CHECKED
    A(n+1,n-2*l)=FACTOR_FORCING*l_forcing*sin(psi1);%CHECKED
    A(n+1,n-2*l+1)=FACTOR_FORCING*l_forcing*cos(psi1);%CHECKED
    A(n+1,n-2*m+1)=FACTOR_FORCING*m_forcing;%CHECKED
    A(n+1,n)=imag(E_A);%CHECKED
    A(n+1,n+1)=real(E_A);%CHECKED
    A(n+1,n+2*m+1)=FACTOR_FORCING*m_forcing;%CHECKED%MISTAKE
    A(n+1,n+2*l)=-FACTOR_FORCING*l_forcing*sin(psi1);%CHECKED
    A(n+1,n+2*l+1)=FACTOR_FORCING*l_forcing*cos(psi1);%CHECKED
    A(n+1,n+2*p)=-FACTOR_FORCING*p_forcing*sin(psi2);%CHECKED
    A(n+1,n+2*p+1)=FACTOR_FORCING*p_forcing*cos(psi2);%CHECKED
    % rhs
    rhs_temp=0+0*1i;
    for r=1:length(p1) % index of h
        r_wn=r-N; % corresponding wavenumber
        s_wn=n_count-r_wn; %'paired' wavenumber
        s=s_wn+N; % corresponding index
        if s<2*N && s>0 %CHECKED
        rhs_temp=rhs_temp+k*(k/2)^2*p1(r)*p1(s);
        end
    end
    rhs(n,1)=real(rhs_temp);
    rhs(n+1,1)=imag(rhs_temp);
end

for n=2*(N-p)+1:2:2*N-1 % because you have a zero mode%CHECKED
    n_count=(n-1)/2;%CHECKED
    E_A=-(n_count)^2+FACTOR_MID*1i*(n_count)...%CHECKED
        +FACTOR_END+visc_2;%CHECKED
    % real
    A(n,n-2*p)=FACTOR_FORCING*p_forcing*cos(psi2);%CHECKED
    A(n,n-2*p+1)=-FACTOR_FORCING*p_forcing*sin(psi2);%CHECKED
    A(n,n-2*l)=FACTOR_FORCING*l_forcing*cos(psi1);%CHECKED
    A(n,n-2*l+1)=-FACTOR_FORCING*l_forcing*sin(psi1);%CHECKED
    A(n,n-2*m)=FACTOR_FORCING*m_forcing;%CHECKED
    A(n,n)=real(E_A); %CHECKED
    A(n,n+1)=-imag(E_A);%C%CHECKED
    if n_count+m<=N-1%CHECKED
    A(n,n+2*m)=FACTOR_FORCING*m_forcing;%CHECKED
    end
    if n_count+l<=N-1%CHECKED
    A(n,n+2*l)=FACTOR_FORCING*l_forcing*cos(psi1);%CHECKED
    A(n,n+2*l+1)=FACTOR_FORCING*l_forcing*sin(psi1);%CHECKED
    end
    
    % imag
    A(n+1,n-2*p)=FACTOR_FORCING*p_forcing*sin(psi2);%CHECKED
    A(n+1,n-2*p+1)=FACTOR_FORCING*p_forcing*cos(psi2);%CHECKED
    A(n+1,n-2*l)=FACTOR_FORCING*l_forcing*sin(psi1);%CHECKED
    A(n+1,n-2*l+1)=FACTOR_FORCING*l_forcing*cos(psi1);%CHECKED
    A(n+1,n-2*m+1)=FACTOR_FORCING*m_forcing;%CHECKED
    A(n+1,n)=imag(E_A);%CHECKED
    A(n+1,n+1)=real(E_A);%C%CHECKED
    if n_count+m<=N-1%CHECKED
    A(n+1,n+2*m+1)=FACTOR_FORCING*m_forcing;%CHECKED%MISTAKE
    end
    if n_count+l<=N-1%CHECKED
    A(n+1,n+2*l)=-FACTOR_FORCING*l_forcing*sin(psi1);%CHECKED%MISTAKE
    A(n+1,n+2*l+1)=FACTOR_FORCING*l_forcing*cos(psi1);
    end
    
    % rhs
    rhs_temp=0+0*1i;
    for r=1:length(p1) % index of h
        r_wn=r-N; % corresponding wavenumber
        s_wn=n_count-r_wn; %'paired' wavenumber
        s=s_wn+N; % corresponding index
        if s<2*N && s>0 %CHECKED
        rhs_temp=rhs_temp+k*(k/2)^2*p1(r)*p1(s);
        end
    end
    rhs(n,1)=real(rhs_temp);
    rhs(n+1,1)=imag(rhs_temp);
end

y=A\rhs;%CHECKED