function y=solve_second_order_m_minus_l(h1m,p1m,h1l,p1l,kl,B,C,epsilon_2,a_c,m,l,xi,psi)
% solver at second order for h2_ml
k=1; % nondim wave number %CHECKED
N=length(p1m); % number of time modes %CHECKED

hm=full_H(h1m);%CHECKED
pm=full_H(p1m);%CHECKED
hl=full_SH(h1l);%CHECKED
pl=full_SH(p1l);%CHECKED

A=zeros(2*N,2*N);%CHECKED
rhs=zeros(2*N,1);%CHECKED

FACTOR_MID=4*epsilon_2*1i*(k-kl)^2;%CHECKED
FACTOR_END=abs(k-kl)*(B+C*(k-kl)^2);%CHECKED
FACTOR_FORCING=B*(abs(k-kl)/2)*a_c;

for ni=1:2:2*l-1 % because you have a zero mode%CHECKED
    n_count=(ni-1)/2;%CHECKED
    E_A=-(n_count+0.5)^2+FACTOR_MID*(n_count+0.5)...%CHECKED
        +FACTOR_END;%CHECKED
    % real
    A(ni,2*abs(n_count-l)-1)=A(ni,2*abs(n_count-l)-1)+FACTOR_FORCING*sin(xi)*cos(psi);%CHECKED
    A(ni,2*abs(n_count-l))=A(ni,2*abs(n_count-l))+FACTOR_FORCING*a_c*sin(xi)*sin(psi);%CHECKED % flip sign of imag part
    if n_count-m<0%CHECKED
        A(ni,2*abs(n_count-m)-1)=A(ni,2*abs(n_count-m)-1)+FACTOR_FORCING*cos(xi);%CHECKED
    else
        A(ni,ni-2*m)=A(ni,ni-2*m)+FACTOR_FORCING*cos(xi);%CHECKED
    end
    A(ni,ni)=A(ni,ni)+real(E_A);%CHECKED
    A(ni,ni+1)=A(ni,ni+1)-imag(E_A);%CHECKED
    A(ni,ni+2*m)=A(ni,ni+2*m)+FACTOR_FORCING*cos(xi);%CHECKED
    A(ni,ni+2*l)=A(ni,ni+2*l)+FACTOR_FORCING*sin(xi)*cos(psi);%CHECKED
    A(ni,ni+2*l+1)=A(ni,ni+2*l+1)+FACTOR_FORCING*sin(xi)*sin(psi);%CHECKED
    
    % imag
    A(ni+1,2*abs(n_count-l)-1)=A(ni+1,2*abs(n_count-l)-1)+FACTOR_FORCING*sin(xi)*sin(psi);%CHECKED
    A(ni+1,2*abs(n_count-l))=A(ni+1,2*abs(n_count-l))-FACTOR_FORCING*sin(xi)*cos(psi);%CHECKED
    if n_count-m<0%CHECKED
        A(ni+1,2*abs(n_count-m))=A(ni+1,2*abs(n_count-m))-FACTOR_FORCING*cos(xi);
    else
        A(ni+1,ni-2*m+1)=A(ni+1,ni-2*m+1)+FACTOR_FORCING*cos(xi);%CHECKED
    end
    A(ni+1,ni)=A(ni+1,ni)+imag(E_A); %CHECKED
    A(ni+1,ni+1)=A(ni+1,ni+1)+real(E_A);%CHECKED
    A(ni+1,ni+2*m+1)=A(ni+1,ni+2*m+1)+FACTOR_FORCING*cos(xi);%CHECKED
    A(ni+1,ni+2*l)=A(ni+1,ni+2*l)-FACTOR_FORCING*sin(xi)*sin(psi);%CHECKED
    A(ni+1,ni+2*l+1)=A(ni+1,ni+2*l+1)+FACTOR_FORCING*sin(xi)*cos(psi);%CHECKED
    
    % rhs
    rhs_temp1=0+0*1i;%CHECKED
    for r=1:length(hl) % index of h %CHECKED
        r_wn=r-N-1; % corresponding wavenumber %CHECKED
        s_wn=n_count-r_wn; %'paired' wavenumber %CHECKED
        s=s_wn+N; % corresponding index %CHECKED
        if s<2*N && s>0 %CHECKED
        rhs_temp1=rhs_temp1+pm(s)*hl(r); %CHECKED
        end
    end
    rhs_temp2=0+0*1i; %CHECKED
    for r=1:length(pl) % index of h %CHECKED
        r_wn=r-N-1; % corresponding wavenumber %CHECKED
        s_wn=n_count-r_wn; %'paired' wavenumber %CHECKED
        s=s_wn+N; % corresponding index %CHECKED
        if s<2*N && s>0 %CHECKED
        rhs_temp2=rhs_temp2+hm(s)*pl(r); %CHECKED
        end
    end
    rhs(ni,1)=kl*(kl-k-abs(k-kl))*real((1i*(n_count+0.5)+2*epsilon_2*(k-kl)^2)*(rhs_temp1))+...
        k*(k-kl-abs(k-kl))*real((1i*(n_count+0.5)+2*epsilon_2*(k-kl)^2)*(rhs_temp2)); %CHECKED
    rhs(ni+1,1)=kl*(kl-k-abs(k-kl))*imag((1i*(n_count+0.5)+2*epsilon_2*(k-kl)^2)*(rhs_temp1))+...
        k*(k-kl-abs(k-kl))*imag((1i*(n_count+0.5)+2*epsilon_2*(k-kl)^2)*(rhs_temp2)); %CHECKED
end

for ni=2*l+1:2:2*(N-l)-1 % because you have a zero mode %CHECKED
    n_count=(ni-1)/2; %CHECKED
    E_A=-(n_count+0.5)^2+FACTOR_MID*(n_count+0.5)...%CHECKED
        +FACTOR_END;%CHECKED
    % real
    A(ni,ni-2*l)=FACTOR_FORCING*sin(xi)*cos(psi);%CHECKED
    A(ni,ni-2*l+1)=-FACTOR_FORCING*sin(xi)*sin(psi);%CHECKED
    A(ni,ni-2*m)=FACTOR_FORCING*cos(xi);%CHECKED
    A(ni,ni)=real(E_A);%CHECKED
    A(ni,ni+1)=-imag(E_A);%CHECKED
    A(ni,ni+2*m)=FACTOR_FORCING*cos(xi);%CHECKED
    A(ni,ni+2*l)=FACTOR_FORCING*sin(xi)*cos(psi);%CHECKED
    A(ni,ni+2*l+1)=FACTOR_FORCING*sin(xi)*sin(psi);%CHECKED
    
    % imag
    A(ni+1,ni-2*l)=FACTOR_FORCING*sin(xi)*sin(psi);%CHECKED
    A(ni+1,ni-2*l+1)=FACTOR_FORCING*sin(xi)*cos(psi);%CHECKED
    A(ni+1,ni-2*m+1)=FACTOR_FORCING*cos(xi);%CHECKED
    A(ni+1,ni)=imag(E_A);%CHECKED
    A(ni+1,ni+1)=real(E_A);%CHECKED
    A(ni+1,ni+2*m+1)=FACTOR_FORCING*cos(xi);%CHECKED
    A(ni+1,ni+2*l)=-FACTOR_FORCING*sin(xi)*sin(psi);%CHECKED
    A(ni+1,ni+2*l+1)=FACTOR_FORCING*sin(xi)*cos(psi);%CHECKED
    
    % rhs
    rhs_temp1=0+0*1i;%CHECKED
    for r=1:length(hl) % index of h %CHECKED
        r_wn=r-N-1; % corresponding wavenumber %CHECKED
        s_wn=n_count-r_wn; %'paired' wavenumber %CHECKED
        s=s_wn+N; % corresponding index %CHECKED
        if s<2*N && s>0 %CHECKED
        rhs_temp1=rhs_temp1+pm(s)*hl(r); %CHECKED
        end
    end
    rhs_temp2=0+0*1i; %CHECKED
    for r=1:length(pl) % index of h %CHECKED
        r_wn=r-N-1; % corresponding wavenumber %CHECKED
        s_wn=n_count-r_wn; %'paired' wavenumber %CHECKED
        s=s_wn+N; % corresponding index %CHECKED
        if s<2*N && s>0 %CHECKED
        rhs_temp2=rhs_temp2+hm(s)*pl(r); %CHECKED
        end
    end
    rhs(ni,1)=kl*(kl-k-abs(k-kl))*real((1i*(n_count+0.5)+2*epsilon_2*(k-kl)^2)*(rhs_temp1))+...
        k*(k-kl-abs(k-kl))*real((1i*(n_count+0.5)+2*epsilon_2*(k-kl)^2)*(rhs_temp2)); %CHECKED
    rhs(ni+1,1)=kl*(kl-k-abs(k-kl))*imag((1i*(n_count+0.5)+2*epsilon_2*(k-kl)^2)*(rhs_temp1))+...
        k*(k-kl-abs(k-kl))*imag((1i*(n_count+0.5)+2*epsilon_2*(k-kl)^2)*(rhs_temp2)); %CHECKED
end

for ni=2*(N-l)+1:2:2*N-1 % because you have a zero mode %CHECKED
    n_count=(ni-1)/2; %CHECKED
    E_A=-(n_count+0.5)^2+FACTOR_MID*(n_count+0.5)...%CHECKED
        +FACTOR_END;%CHECKED
    % real
    A(ni,ni-2*l)=FACTOR_FORCING*sin(xi)*cos(psi);%CHECKED
    A(ni,ni-2*l+1)=-FACTOR_FORCING*sin(xi)*sin(psi);%CHECKED
    A(ni,ni-2*m)=FACTOR_FORCING*cos(xi);%CHECKED
    A(ni,ni)=real(E_A);%CHECKED
    A(ni,ni+1)=-imag(E_A);%CHECKED
    if n_count+m<=N-1%CHECKED
    A(ni,ni+2*m)=FACTOR_FORCING*cos(xi);%CHECKED
    end
    
    % imag
    A(ni+1,ni-2*l)=FACTOR_FORCING*sin(xi)*sin(psi);%CHECKED
    A(ni+1,ni-2*l+1)=FACTOR_FORCING*sin(xi)*cos(psi);%CHECKED
    A(ni+1,ni-2*m+1)=FACTOR_FORCING*cos(xi);%CHECKED
    A(ni+1,ni)=imag(E_A);%CHECKED
    A(ni+1,ni+1)=real(E_A);%CHECKED
    if n_count+m<=N-1%CHECKED
    A(ni+1,ni+2*m+1)=FACTOR_FORCING*cos(xi);%CHECKED
    end
    % rhs
    rhs_temp1=0+0*1i;%CHECKED
    for r=1:length(hl) % index of h %CHECKED
        r_wn=r-N-1; % corresponding wavenumber %CHECKED
        s_wn=n_count-r_wn; %'paired' wavenumber %CHECKED
        s=s_wn+N; % corresponding index %CHECKED
        if s<2*N && s>0 %CHECKED
        rhs_temp1=rhs_temp1+pm(s)*hl(r); %CHECKED
        end
    end
    rhs_temp2=0+0*1i; %CHECKED
    for r=1:length(pl) % index of h %CHECKED
        r_wn=r-N-1; % corresponding wavenumber %CHECKED
        s_wn=n_count-r_wn; %'paired' wavenumber %CHECKED
        s=s_wn+N; % corresponding index %CHECKED
        if s<2*N && s>0 %CHECKED
        rhs_temp2=rhs_temp2+hm(s)*pl(r); %CHECKED
        end
    end
    rhs(ni,1)=kl*(kl-k-abs(k-kl))*real((1i*(n_count+0.5)+2*epsilon_2*(k-kl)^2)*(rhs_temp1))+...
        k*(k-kl-abs(k-kl))*real((1i*(n_count+0.5)+2*epsilon_2*(k-kl)^2)*(rhs_temp2)); %CHECKED
    rhs(ni+1,1)=kl*(kl-k-abs(k-kl))*imag((1i*(n_count+0.5)+2*epsilon_2*(k-kl)^2)*(rhs_temp1))+...
        k*(k-kl-abs(k-kl))*imag((1i*(n_count+0.5)+2*epsilon_2*(k-kl)^2)*(rhs_temp2)); %CHECKED
end
y=A\rhs;
end