function y=solve_second_order_ml(p1m,p1l,kl,B,C,epsilon_2,a_c,m,l,xi,psi)
% solver at second order for h2_ml, subharmonic
k=1; % nondim wave number %CHECKED
N=length(p1m); % number of time modes %CHECKED

pm=full_H(p1m); %CHECKED
pl=full_SH(p1l); %CHECKED

A=zeros(2*N,2*N); %CHECKED
rhs=zeros(2*N,1); %CHECKED

FACTOR_MID=4*epsilon_2*(k+kl)^2*1i;
FACTOR_END=(k+kl)*(B+C*(k+kl)^2);
FACTOR_FORCING=B*((k+kl)/2)*a_c*sin(xi);

for n_i=1:2:2*l-1 % because you have a zero mode %CHECKED
    n_count=(n_i-1)/2;%CHECKED
    E_A=-(n_count+0.5)^2+FACTOR_MID*(n_count+0.5)...%CHECKED
        +FACTOR_END;%CHECKED
    % real
    A(n_i,2*abs(n_count-l)-1)=A(n_i,2*abs(n_count-l)-1)+FACTOR_FORCING*sin(xi)*cos(psi);%CHECKED
    A(n_i,2*abs(n_count-l))=A(n_i,2*abs(n_count-l))+FACTOR_FORCING*sin(xi)*sin(psi);%CHECKED % flip sign of imag part
    if n_count-m<0%CHECKED
        A(n_i,2*abs(n_count-m)-1)=A(n_i,2*abs(n_count-m)-1)+FACTOR_FORCING*cos(xi);%CHECKED
    else
        A(n_i,n_i-2*m)=A(n_i,n_i-2*m)+FACTOR_FORCING*cos(xi);%CHECKED
    end
    A(n_i,n_i)=A(n_i,n_i)+real(E_A);%CHECKED
    A(n_i,n_i+1)=A(n_i,n_i+1)-imag(E_A);%CHECKED
    A(n_i,n_i+2*m)=A(n_i,n_i+2*m)+FACTOR_FORCING*cos(xi);%CHECKED
    A(n_i,n_i+2*l)=A(n_i,n_i+2*l)+FACTOR_FORCING*sin(xi)*cos(psi);%CHECKED
    A(n_i,n_i+2*l+1)=A(n_i,n_i+2*l+1)+FACTOR_FORCING*sin(xi)*sin(psi);%CHECKED
    
    % imag
    A(n_i+1,2*abs(n_count-l)-1)=A(n_i+1,2*abs(n_count-l)-1)+FACTOR_FORCING*sin(xi)*sin(psi);%CHECKED
    A(n_i+1,2*abs(n_count-l))=A(n_i+1,2*abs(n_count-l))-FACTOR_FORCING*sin(xi)*cos(psi);%CHECKED
    if n_count-m<0
        A(n_i+1,2*abs(n_count-m))=A(n_i+1,2*abs(n_count-m))-FACTOR_FORCING*cos(xi);%CHECKED
    else
        A(n_i+1,n_i-2*m+1)=A(n_i+1,n_i-2*m+1)+FACTOR_FORCING*cos(xi);%CHECKED
    end
    A(n_i+1,n_i)=A(n_i+1,n_i)+imag(E_A);%CHECKED
    A(n_i+1,n_i+1)=A(n_i+1,n_i+1)+real(E_A);%CHECKED
    A(n_i+1,n_i+2*m)=A(n_i+1,n_i+2*m)+FACTOR_FORCING*cos(xi);%CHECKED
    A(n_i+1,n_i+2*l)=A(n_i+1,n_i+2*l)-FACTOR_FORCING*sin(xi)*sin(psi);%CHECKED
    A(n_i+1,n_i+2*l+1)=A(n_i+1,n_i+2*l+1)+FACTOR_FORCING*sin(xi)*cos(psi);%CHECKED
    
    % rhs
    rhs_temp=0+0*1i;%CHECKED
    for r=1:length(pm) % index of h %CHECKED
        r_wn=r-N-1; % corresponding wavenumber %CHECKED
        s_wn=n_count-r_wn; %'paired' wavenumber %CHECKED
        s=s_wn+N; % corresponding index %CHECKED
        if s<2*N && s>0 %CHECKED
        rhs_temp=rhs_temp+pm(s,1)*pl(r,1); %CHECKED
        end
    end
    rhs(n_i,1)=2*(k+kl)*k*kl*real(rhs_temp);%CHECKED
    rhs(n_i+1,1)=2*(k+kl)*k*kl*imag(rhs_temp);%CHECKED
end
for n_i=2*l+1:2:2*(N-l)-1 % because you have a zero mode %CHECKED
    n_count=(n_i-1)/2; %CHECKED
    E_A=-(n_count+0.5)^2+FACTOR_MID*(n_count+0.5)...%CHECKED
        +FACTOR_END;%CHECKED
    % real
    A(n_i,n_i-2*l)=FACTOR_FORCING*sin(xi)*cos(psi);%CHECKED
    A(n_i,n_i-2*l+1)=-FACTOR_FORCING*sin(xi)*sin(psi);%CHECKED
    A(n_i,n_i-2*m)=FACTOR_FORCING*cos(xi);%CHECKED
    A(n_i,n_i)=real(E_A); %CHECKED
    A(n_i,n_i+1)=-imag(E_A);%CHECKED
    A(n_i,n_i+2*m)=FACTOR_FORCING*cos(xi);%CHECKED
    A(n_i,n_i+2*l)=FACTOR_FORCING*sin(xi)*cos(psi);%CHECKED
    A(n_i,n_i+2*l+1)=FACTOR_FORCING*sin(xi)*sin(psi);%CHECKED
    
    % imag
    A(n_i+1,n_i-2*l)=FACTOR_FORCING*sin(xi)*sin(psi);%CHECKED
    A(n_i+1,n_i-2*l+1)=FACTOR_FORCING*sin(xi)*cos(psi);%CHECKED
    A(n_i+1,n_i-2*m+1)=FACTOR_FORCING*cos(xi);%CHECKED
    A(n_i+1,n_i)=imag(E_A); %CHECKED
    A(n_i+1,n_i+1)=real(E_A);%CHECKED
    A(n_i+1,n_i+2*m+1)=FACTOR_FORCING*cos(xi);%CHECKED
    A(n_i+1,n_i+2*l)=-FACTOR_FORCING*sin(xi)*sin(psi);%CHECKED
    A(n_i+1,n_i+2*l+1)=FACTOR_FORCING*sin(xi)*cos(psi);%CHECKED
    
    % rhs
    rhs_temp=0+0*1i;%CHECKED
    for r=1:length(pm) % index of h %CHECKED
        r_wn=r-N-1; % corresponding wavenumber %CHECKED
        s_wn=n_count-r_wn; %'paired' wavenumber %CHECKED
        s=s_wn+N; % corresponding index %CHECKED
        if s<2*N && s>0 %CHECKED
        rhs_temp=rhs_temp+pm(s,1)*pl(r,1); %CHECKED
        end
    end
    rhs(n_i,1)=2*(k+kl)*k*kl*real(rhs_temp);%CHECKED
    rhs(n_i+1,1)=2*(k+kl)*k*kl*imag(rhs_temp);%CHECKED
end
for n_i=2*(N-l)+1:2:2*N-1 % because you have a zero mode %CHECKED
    n_count=(n_i-1)/2; %CHECKED
    E_A=-(n_count+0.5)^2+FACTOR_MID*(n_count+0.5)... %CHECKED
        +FACTOR_END; %CHECKED
    % real
    A(n_i,n_i-2*l)=FACTOR_FORCING*sin(xi)*cos(psi); %CHECKED
    A(n_i,n_i-2*l+1)=-FACTOR_FORCING*sin(xi)*sin(psi);%CHECKED
    A(n_i,n_i-2*m)=FACTOR_FORCING*cos(xi);%CHECKED
    A(n_i,n_i)=real(E_A);%CHECKED
    A(n_i,n_i+1)=-imag(E_A);%CHECKED
    if n_count+m<=N-1%CHECKED
    A(n_i,n_i+2*m)=FACTOR_FORCING*cos(xi);%CHECKED
    end
    
    % imag
    A(n_i+1,n_i-2*l)=FACTOR_FORCING*sin(xi)*sin(psi);%CHECKED
    A(n_i+1,n_i-2*l+1)=FACTOR_FORCING*sin(xi)*cos(psi);%CHECKED
    A(n_i+1,n_i-2*m+1)=FACTOR_FORCING*cos(xi);%CHECKED
    A(n_i+1,n_i)=imag(E_A);%CHECKED
    A(n_i+1,n_i+1)=real(E_A);%CHECKED
    if n_count+m<=N-1%CHECKED
    A(n_i+1,n_i+2*m+1)=FACTOR_FORCING*cos(xi);%CHECKED
    end
    
    % rhs
    rhs_temp=0+0*1i;%CHECKED
    for r=1:length(pm) % index of h %CHECKED
        r_wn=r-N-1; % corresponding wavenumber %CHECKED
        s_wn=n_count-r_wn; %'paired' wavenumber %CHECKED
        s=s_wn+N; % corresponding index %CHECKED
        if s<2*N && s>0 %CHECKED
        rhs_temp=rhs_temp+pm(s,1)*pl(r,1); %CHECKED
        end
    end
    rhs(n_i,1)=2*(k+kl)*k*kl*real(rhs_temp);%CHECKED
    rhs(n_i+1,1)=2*(k+kl)*k*kl*imag(rhs_temp);%CHECKED
end
y=A\rhs;