% define fontsize and style for consistent use below and physical figure size
fs=10;
fn='times';
wd=8;
ht=7;

% set physical paper size for output and ensure figure is in correct position
set(1,'paperunits','centimeters');
set(1,'papersize',[wd ht]);
set(1,'paperposition',[0 0 wd ht]);

% create x and y labels and render using latex
hx=xlabel('$a_c\cos(\chi)$','interpreter','latex');
hy=ylabel('$a_c\sin(\chi)$','interpreter','latex');

title('B=1, C=1','Interpreter','latex');

% create a legend and render using latex
% hl=legend('$y=\sin^2 t$','$y=\cos^2 t$');
% set(hl,'interpreter','latex');

% set the axis labels and numbers in the fontsize and style we want (gca means get current axis)
set(hx,'fontsize',fs); set(hx,'fontname',fn);
set(hy,'fontsize',fs); set(hy,'fontname',fn);
set(gca,'fontsize',fs); set(gca,'fontname',fn);

% minor aesthetic tweaks
box on; set(gca,'tickdir','out');
%%
% export figure to high resolution png (for Powerpoint/Word/Web) and pdf (Latex)
print(1,'-dpng','-r1200','./bland_phase.png');
% print(1,'-dpdf','demoFigure.pdf');