function [y,z,T,l2]=step_in_ETD2_continued_2d_arc(time_start,time_end,time_steps_per_period,...
    time_steps_tot,x_l,y_l,N_x,N_y,a_forcing,epsilon_2,B,C,...
    sin_2_t,sample_index,x_i,y_i,f_h_older,f_h_old,f_phi_older,f_phi_old,file_path1,file_path2)
% solutions should come in pre-filtered
% set write path for L2
if not(isfile(strcat(file_path1,'/T_count.txt')))
T_count=1;
writematrix(T_count,strcat(file_path1,'/T_count.txt'))
else
T_count=load(strcat(file_path1,'/T_count.txt'))+1;
writematrix(T_count,strcat(file_path1,'/T_count.txt'))
end
if T_count==1
writematrix(f_h_old(N_y/2,:),strcat(file_path1,'/half_y_sample0.txt'),...
            'writemode','append')
writematrix(f_h_old(:,N_x/2)',strcat(file_path1,'/half_x_sample0.txt'),...
            'writemode','append')
writematrix(f_h_older,strcat(file_path1,'/IC_hmin1.txt'));
        writematrix(f_phi_older,strcat(file_path1,'/IC_phimin1.txt'));
        writematrix(f_h_old,strcat(file_path1,'/IC_h.txt'));
        writematrix(f_phi_old,strcat(file_path1,'/IC_phi.txt'));

end
% time step
DT=(time_end-time_start)/time_steps_tot; %CHECKED% CHECKED% CHECKED

K_x=zeros(1,N_x);
K_x(2:N_x/2)=(2*pi/x_l)*[1:N_x/2-1];
K_x(N_x/2+2:end)=-fliplr(K_x(2:N_x/2));
% first step with ETD 1 (i=1)
n_setter=2:floor((N_x-1)/4)+1;
% iterate through modes
for n_x=[1,n_setter,(N_x-length(n_setter)+1):N_x] % index of last kept mode in x
    for n_y=1:floor((N_y-1)/4)+1 % index of last kept mode in y
        if n_x>1 || n_y>1
        K_y(n_y)=2*pi*(n_y-1)/y_l;
        % linear matrix
        L_nxy{n_x,n_y}=[-2*epsilon_2*(K_x(n_x)^2+K_y(n_y)^2), sqrt(K_x(n_x)^2+K_y(n_y)^2);...
            -B-C*(K_x(n_x)^2+K_y(n_y)^2), -2*epsilon_2*(K_x(n_x)^2+K_y(n_y)^2)];
        % work out exponential matrix
        [P,D]=eig(L_nxy{n_x,n_y});
        exp_Lhxy{n_x,n_y}=real(P*[exp(DT*D(1,1)),0;0,exp(DT*D(2,2))]*inv(P));
        M1xy{n_x,n_y}=L_nxy{n_x,n_y}\(exp_Lhxy{n_x,n_y}-eye(2,2));
        M2xy{n_x,n_y}=inv(L_nxy{n_x,n_y})*inv(L_nxy{n_x,n_y})*(exp_Lhxy{n_x,n_y}-(eye(2,2)+(L_nxy{n_x,n_y}).*DT))/DT;
        end
    end
end

% set start of solution, pre-filtered
U_old(:,:,1)=fft2(f_h_older);
U_old(:,:,2)=fft2(f_phi_older);
U_new(:,:,1)=fft2(f_h_old);
U_new(:,:,2)=fft2(f_phi_old);
% setup nonlinear part
NL_old=nonlinear_part_2d(U_old,x_l,y_l,C);
fft_NL_old(:,:,1)=fft2(NL_old(:,:,1));
fft_NL_old(:,:,2)=fft2(NL_old(:,:,2));
% sample parts of the solution
s_count=1;
% counter for time dependent part
t_count_old=-1;%CHECKED
% iterate with ETD 2
for i=1:time_steps_tot
    % update time dependent part, add one to these for index
    t_count_older=mod(t_count_old,time_steps_per_period);
    t_count_old=mod(t_count_older+1,time_steps_per_period);
    
    % update older solutions
    U_older=U_old;
    U_old=U_new;
    
    % update nonlinear part
    fft_NL_older=fft_NL_old;
    NL_old=nonlinear_part_2d(U_old,x_l,y_l,C);
    fft_NL_old(:,:,1)=fft2(NL_old(:,:,1));
    fft_NL_old(:,:,2)=fft2(NL_old(:,:,2));
    
    % iterate through modes
    for n_x=[1,n_setter,(N_x-length(n_setter)+1):N_x] % index of last kept mode in x
    for n_y=1:floor((N_y-1)/4)+1 % index of last kept mode in y
        if n_x>1 || n_y>1
        vec_older=[U_older(n_y,n_x,1);U_older(n_y,n_x,2)]; % mistake, should have a 2 in second entry
        vec_old=[U_old(n_y,n_x,1);U_old(n_y,n_x,2)];
        NL_vec_older=[fft_NL_older(n_y,n_x,1);fft_NL_older(n_y,n_x,2)];        
        NL_vec_old=[fft_NL_old(n_y,n_x,1);fft_NL_old(n_y,n_x,2)];
        vec_new=ETD_2(vec_older,vec_old,sin_2_t(t_count_older+1),...
        sin_2_t(t_count_old+1),exp_Lhxy{n_x,n_y},M1xy{n_x,n_y},M2xy{n_x,n_y},a_forcing...
        ,B,NL_vec_older,NL_vec_old);
        U_new(n_y,n_x,1)=vec_new(1,1); 
        U_new(n_y,n_x,2)=vec_new(2,1);
        end
    end
    end
    % sort out other modes
U_new(N_y-floor((N_y-1)/4)+1:end,1,1)=flipud(conj(U_new(2:n_y,1,1)));
U_new(N_y-floor((N_y-1)/4)+1:end,1,2)=flipud(conj(U_new(2:n_y,1,2)));
U_new(N_y/2+1,:,1)=zeros(1,N_x);U_new(N_y/2+1,:,2)=zeros(1,N_x);
U_new(:,N_x/2+1,1)=zeros(N_y,1);U_new(:,N_x/2+1,2)=zeros(N_y,1);

U_new(N_y-floor((N_y-1)/4)+1:end,n_setter,1)=rot90(conj(U_new(2:n_y,(N_x-length(n_setter)+1):N_x,1)),2);
U_new(N_y-floor((N_y-1)/4)+1:end,n_setter,2)=rot90(conj(U_new(2:n_y,(N_x-length(n_setter)+1):N_x,2)),2);
U_new(N_y-floor((N_y-1)/4)+1:end,(N_x-length(n_setter)+1):end,1)=rot90(conj(U_new(2:n_y,n_setter,1)),2);
U_new(N_y-floor((N_y-1)/4)+1:end,(N_x-length(n_setter)+1):end,2)=rot90(conj(U_new(2:n_y,n_setter,2)),2);

% filter for dealiasing
h_new=filter_3_2d(ifft2(U_new(:,:,1))); phi_new=filter_3_2d(ifft2(U_new(:,:,2)));
U_new(:,:,1)=fft2(h_new);
U_new(:,:,2)=fft2(phi_new);

    % output per sample
    if mod(i,2*sample_index)==0 && i<=time_steps_tot-2*time_steps_per_period
	writematrix(ifft2(U_old(:,:,1)),strcat(file_path1,'/sol_h_min1time.txt'));
	writematrix(i,strcat(file_path1,'/tracker_sol_h_min_1.txt'));
        writematrix(ifft2(U_new(:,:,1)),strcat(file_path1,'/sol_h.txt'));
        writematrix(i,strcat(file_path1,'/tracker_sol_h.txt'));
	writematrix(ifft2(U_old(:,:,2)),strcat(file_path1,'/sol_phi_min1time.txt'));
        writematrix(i,strcat(file_path1,'/tracker_sol_phi_min_1.txt'));
        writematrix(ifft2(U_new(:,:,2)),strcat(file_path1,'/sol_phi.txt'));
        writematrix(i,strcat(file_path1,'/tracker_sol_phi.txt'));        
	for i_y=1:N_y
        l2hx(1,i_y)=(1/(x_l))*trapz([x_i,x_i(1)+x_l],[h_new(i_y,:),h_new(i_y,1)].^2);
        l2phix(1,i_y)=(1/(x_l))*trapz([x_i,x_i(1)+x_l],[phi_new(i_y,:),phi_new(i_y,1)].^2);
        end
        l2hxy=sqrt((1/(y_l))*trapz([y_i',y_i(1)+y_l],[l2hx(1,:),l2hx(1,1)]));
        l2phixy=sqrt((1/(y_l))*trapz([y_i',y_i(1)+y_l],[l2phix(1,:),l2phix(1,1)]));
        writematrix([l2hxy,l2phixy],strcat(file_path1,'/L2_',num2str(T_count),'.txt'),'writemode','append');%CHECKED
        writematrix(exp((B*a_forcing/2-2*epsilon_2)*(time_start+i*DT)),strcat(file_path1,'/linear_growth.txt'),...
            'writemode','append')%CHECKED
        writematrix((time_start+i*DT),strcat(file_path1,'/running_sample_time.txt'),...
            'writemode','append') %CHECKED
        writematrix(h_new(N_y/2,:),strcat(file_path1,'/half_y_sample',num2str(T_count),'.txt'),...
            'writemode','append')
        writematrix(h_new(:,N_x/2)',strcat(file_path1,'/half_x_sample',num2str(T_count),'.txt'),...
            'writemode','append')
    end
    div_count=1;
    if mod(i,0.5*sample_index)==0
        writematrix(h_new,strcat(file_path2,'/h_progress',num2str(T_count),'.txt'),...
            'writemode','append')
        div_count=div_count+1;
    end
    % output information for the final period
    if i>time_steps_tot-2*time_steps_per_period
        y(:,:,s_count)=h_new;
        z(:,:,s_count)=phi_new;
        T(1,s_count)=exp((B*a_forcing/4-2*epsilon_2)*(time_start+i*DT));
        T(2,s_count)=time_start+i*DT;
        for i_y=1:N_y
        l2hx(1,i_y)=(1/(x_l))*trapz([x_i,x_i(1)+x_l],[h_new(i_y,:),h_new(i_y,1)].^2);
        l2phix(1,i_y)=(1/(x_l))*trapz([x_i,x_i(1)+x_l],[phi_new(i_y,:),phi_new(i_y,1)].^2);
        end
        l2hxy=sqrt((1/(y_l))*trapz([y_i',y_i(1)+y_l],[l2hx(1,:),l2hx(1,1)]));
        l2phixy=sqrt((1/(y_l))*trapz([y_i',y_i(1)+y_l],[l2phix(1,:),l2phix(1,1)]));
        l2(:,s_count)=[l2hxy;l2phixy];
        s_count=s_count+1;
    end
    % output every step
    writematrix(U_new(1,33,1),strcat(file_path2,'/mode_0_32',num2str(T_count),'.txt'),'writemode','append')
    writematrix(U_new(17,17,1),strcat(file_path2,'/mode_16_16',num2str(T_count),'.txt'),'writemode','append')
    writematrix(U_new(1,2,1),strcat(file_path2,'/mode_0_1',num2str(T_count),'.txt'),'writemode','append')
    writematrix(U_new(2,1,1),strcat(file_path2,'/mode_1_0',num2str(T_count),'.txt'),'writemode','append')
    writematrix(U_new(2,2,1),strcat(file_path2,'/mode_1_1',num2str(T_count),'.txt'),'writemode','append')
    writematrix(U_new(3,1,1),strcat(file_path2,'/mode_2_0',num2str(T_count),'.txt'),'writemode','append')
    writematrix(U_new(3,2,1),strcat(file_path2,'/mode_2_1',num2str(T_count),'.txt'),'writemode','append')
    writematrix(U_new(3,3,1),strcat(file_path2,'/mode_2_2',num2str(T_count),'.txt'),'writemode','append')
    writematrix(U_new(2,3,1),strcat(file_path2,'/mode_1_2',num2str(T_count),'.txt'),'writemode','append')
    writematrix(U_new(1,3,1),strcat(file_path2,'/mode_0_2',num2str(T_count),'.txt'),'writemode','append')
    
    writematrix(max(max(h_new)),strcat(file_path1,'/MAX_h',num2str(T_count),'.txt'),...
        'writemode','append')
    writematrix(min(min(h_new)),strcat(file_path1,'/MIN_h',num2str(T_count),'.txt'),...
        'writemode','append')
    writematrix(max(max(phi_new)),strcat(file_path1,'/MAX_phi',num2str(T_count),'.txt'),...
        'writemode','append')
    writematrix(min(min(phi_new)),strcat(file_path1,'/MIN_phi',num2str(T_count),'.txt'),...
        'writemode','append')
    
    writematrix(h_new,strcat(file_path2,'/h_',num2str(T_count),'_',num2str(i),'.txt'))
    if mod(i,time_steps_per_period)==0
        writematrix(h_new,strcat(file_path1,'/h_',num2str(T_count),'_',num2str(i),'.txt'))
    end
end
 writematrix(y,strcat(file_path1,'/final_period_h.txt'))
 writematrix(z,strcat(file_path1,'/final_period_phi.txt'))
% writematrix(T,strcat(file_path,'/final_period_time.txt'))
writematrix(l2,strcat(file_path1,'/final_period_L2.txt'))
writematrix([l2hxy,l2phixy],strcat(file_path1,'/L2_',num2str(T_count),'.txt'),'writemode','append');
writematrix(h_new(N_y/2,:),strcat(file_path1,'/half_y_sample',num2str(T_count),'.txt'),...
            'writemode','append')
writematrix(h_new(:,N_x/2)',strcat(file_path1,'/half_x_sample',num2str(T_count),'.txt'),...
            'writemode','append')
        
writematrix(y(:,:,s_count-2),strcat(file_path1,'/CONT_h_min1.txt'))
writematrix(z(:,:,s_count-2),strcat(file_path1,'/CONT_phi_min1.txt'))
writematrix(y(:,:,s_count-1),strcat(file_path1,'/CONT_h.txt'))
writematrix(z(:,:,s_count-1),strcat(file_path1,'/CONT_phi.txt'))

writematrix(div_count-1,strcat(file_path1,'/div_count',num2str(T_count),'.txt'))
end
